#ifndef SMASHER_H
#define SMASHER_H

#include <material.h>
#include <multiatomdir.h>
#include <actuator.h>
#include "stretch.h"

struct Smasher : public Material {
	bool *move_up;
	bool *move_down;
	//bool *move_right;
	//bool *move_left;
	bool *turn_left;
	bool *turn_right;
	bool *smash;
	float move_speed;
	float turn_speed;
	MultiAtomDir *forward;
	Direction *sideways;
	Roster *body;
	Roster *glove;
	Stretch *spring;

	float extension;
	float ext_speed;
	float ext_dir;

	Smasher(Object *parent, bool *move_up, bool *move_down, bool *turn_right, bool *turn_left, bool *smash, float move_speed, float turn_speed);
	virtual void stepFunc();
	virtual void overrideUpdateLink(Link *l);
	virtual Atom *placeAtom(Atom *a);
	virtual Link *placeLink(Link *l);
};

#endif