#include "smashy.h"

#include <glrenderer.h>
#include <direct.h>
#include <material.h>

Smashy::Smashy(HINSTANCE &hInstance) {
	system = new System(this, 1024, 768, -0.0f);
	renderer = new GLRenderer(this, hInstance);
	renderer->initializeGraphics("Physical Punchers", 1024, 768, 16);

	_chdir("data");

	/*
	player = new Smasher(this, &keys[VK_UP], &keys[VK_DOWN], &keys[VK_RIGHT], &keys[VK_LEFT], &keys[VK_SPACE], 1.0f, 1.0f);
	player->load("smasher.pob", 100, 200);
	*/

	player = new Smasher(this, &keys[VK_UP], &keys[VK_DOWN], &keys[VK_RIGHT], &keys[VK_LEFT], &keys[VK_CONTROL], 1.0f, 1.0f);
	player->load("smasher.pob", 200, 200);

	player = new Smasher(this, &keys['I'], &keys['K'], &keys['L'], &keys['J'], &keys['D'], 1.0f, 1.0f);
	player->load("smasher.pob", 400, 200);

	/*
	Object *blah = new Object(this);
	blah->load("smasher.pob", 400, 200);
	*/

	Material *m = new Material(this);
	m->load("redbox.pob", 500, 500);
	m->load("lemur.pob", 700, 500);

	glClearColor(0.5f, 0.5f, 1.0f, 1.0f);
}

void Smashy::keyDown(int key) {
	Game::keyDown(key);

	if(key == VK_ESCAPE)
		quit = true;
}

void Smashy::stepFunc() {
	Game::stepFunc();

	const float fric = 0.05f;

	Atom *a;
	atoms.begin();
	while(a = atoms.get()) {
		/*
		float dx = a->x - a->ox;
		float dy = a->y - a->oy;
		float d = sqrt(dx * dx + dy * dy);
		if(d > fric) {
			dx /= d;
			dy /= d;
			a->ox += dx * fric;
			a->oy += dy * fric;
		}
		else {
			a->ox = a->x;
			a->oy = a->y;
		}*/

		float dx = a->ox - a->x;
		if(fabs(dx) < 0.01f) a->ox = a->x;
		else a->ox = a->x + dx * 0.98f;

		float dy = a->oy - a->y;
		if(fabs(dy) < 0.01f) a->oy = a->y;
		else a->oy = a->y + dy * 0.98f;
	}
}
